/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: ChartElementFactory.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 22:04:56 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _CHARTELEMENTFACTORY_HXX_
#define _CHARTELEMENTFACTORY_HXX_
namespace binfilter {

class SdrObject;

namespace accessibility
{

class AccessibleBase;
class AccessibleUniqueId;

class ChartElementFactory
{
public:
    /** @return a newly created object (using the new operator) that corresponds
                to the given unique id
     */
    static AccessibleBase * CreateChartElement(
        AccessibleBase * pParent,
        const AccessibleUniqueId & rId );

    /** @return a unique id for the shape given.  It is assumed that the shape
                contains user data denoting the type of object (the object id)
                and in some cases one or two indices.
     */
    static AccessibleUniqueId GetUniqueIdForDrawObject( const SdrObject * pObj );
};
 
}  // namespace accessibility

// _CHARTELEMENTFACTORY_HXX_
} //namespace binfilter
#endif
