/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sch_unmultdp.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 22:38:34 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include "unmultdp.hxx"
#include "strings.hrc"
// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif
// auto strip #include "schresid.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1(SchUndoMultipleDataPoints, SchUndoAction);


//STRIP001 #define RESIZECOUNT 16

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchUndoMultipleDataPoints::SchUndoMultipleDataPoints(ChartModel& rDoc) :
//STRIP001 			SchUndoAction(rDoc)
//STRIP001 {
//STRIP001 	pSets = new List;
//STRIP001 	pRowsAndCols = NULL;
//STRIP001 	SetComment( String( SchResId( STR_UNDO_REMOVEPOINTATTRS )));
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 SchUndoMultipleDataPoints::~SchUndoMultipleDataPoints()
//STRIP001 {
//STRIP001 	while (pSets->Count())
//STRIP001 		delete (SfxItemSet*)pSets->Remove(pSets->Count() - 1);
//STRIP001 	delete[] pRowsAndCols;
//STRIP001 }

/*************************************************************************
|*
|* AddPoint, einen Punkt hinzufuegen
|*
\************************************************************************/

//STRIP001 void SchUndoMultipleDataPoints::AddPoint(short nCol, short nRow)
//STRIP001 {
//STRIP001 	long nCount = pSets->Count();
//STRIP001 
//STRIP001 	// wenn es noch kein Array gibt, wird eines erzeugt
//STRIP001 	if (!pRowsAndCols)
//STRIP001 	{
//STRIP001 		pRowsAndCols = new short[RESIZECOUNT * 2 * sizeof(short)];
//STRIP001 	}
//STRIP001 
//STRIP001 	// wenn es existiert, aber nicht gross genug ist, wird es umkopiert
//STRIP001 	else if (nCount % RESIZECOUNT == 0)
//STRIP001 	{
//STRIP001 		short* pNewArray = new short[(nCount + RESIZECOUNT) * sizeof(short)];
//STRIP001 		memcpy(pNewArray, pRowsAndCols, nCount * sizeof(short));
//STRIP001 		delete[] pRowsAndCols;
//STRIP001 		pRowsAndCols = pNewArray;
//STRIP001 	}
//STRIP001 
//STRIP001 	// Reihe und Spalte merken
//STRIP001 	pRowsAndCols[nCount] = nRow;
//STRIP001 	pRowsAndCols[nCount + 1] = nCol;
//STRIP001 
//STRIP001 	// das alte ItemSet merken
//STRIP001 	SfxItemSet* pOldAttr = new SfxItemSet(rDoc.GetDataPointAttr(nCol, nRow));
//STRIP001 	pSets->Insert(pOldAttr, LIST_APPEND);
//STRIP001 	pSets->Insert((void*)1, LIST_APPEND);   // Dummy fuer neues Set
//STRIP001 }

/*************************************************************************
|*
|* CopyNewAttributes, die neuen Attribute merken
|*
\************************************************************************/

//STRIP001 void SchUndoMultipleDataPoints::CopyNewAttributes()
//STRIP001 {
//STRIP001 	USHORT nPointCount = (USHORT)pSets->Count() / 2;
//STRIP001 
//STRIP001 	for (USHORT nPoint = 0; nPoint < nPointCount; nPoint++)
//STRIP001 	{
//STRIP001 		short nRow = pRowsAndCols[2 * nPoint];
//STRIP001 		short nCol = pRowsAndCols[2 * nPoint + 1];
//STRIP001 		SfxItemSet* pNewAttr = new SfxItemSet(rDoc.GetDataPointAttr(nCol, nRow));
//STRIP001 		pSets->Replace(pNewAttr, 2 * nPoint + 1);
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* Undo
|*
\************************************************************************/

//STRIP001 void SchUndoMultipleDataPoints::Undo()
//STRIP001 {
//STRIP001 	USHORT nPointCount = (USHORT)pSets->Count() / 2;
//STRIP001 
//STRIP001 	DBG_ASSERT(nPointCount, "keine Punkte");
//STRIP001 
//STRIP001 	BOOL bTest = FALSE;
//STRIP001 
//STRIP001 	for (USHORT nPoint = 0; nPoint < nPointCount; nPoint++)
//STRIP001 	{
//STRIP001 		short nRow = pRowsAndCols[2 * nPoint];
//STRIP001 		short nCol = pRowsAndCols[2 * nPoint + 1];
//STRIP001 		SfxItemSet* pOldAttr = (SfxItemSet*)pSets->GetObject(2 * nPoint);
//STRIP001 		SdrObject* pObj = rDoc.GetDataPointObj(nCol, nRow);
//STRIP001 
//STRIP001 		// es gibt nicht immer ein entspr. Objekt im Drawing-Layer
//STRIP001 		if (pObj)
//STRIP001 		{
//STRIP001 							// nicht mergen, nicht BuildChart() rufen
//STRIP001 			rDoc.ChangeDataPointAttr(*pOldAttr, *pObj, FALSE, FALSE);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			rDoc.PutDataPointAttr(nCol, nRow, *pOldAttr,FALSE);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	rDoc.BuildChart(FALSE);
//STRIP001 }

/*************************************************************************
|*
|* Redo
|*
\************************************************************************/

//STRIP001 void SchUndoMultipleDataPoints::Redo()
//STRIP001 {
//STRIP001 	USHORT nPointCount = (USHORT)pSets->Count() / 2;
//STRIP001 
//STRIP001 	for (USHORT nPoint = 0; nPoint < nPointCount; nPoint++)
//STRIP001 	{
//STRIP001 		short nRow = pRowsAndCols[2 * nPoint];
//STRIP001 		short nCol = pRowsAndCols[2 * nPoint + 1];
//STRIP001 		SfxItemSet* pNewAttr = (SfxItemSet*)pSets->GetObject(2 * nPoint + 1);
//STRIP001 		SdrObject* pObj = rDoc.GetDataPointObj(nCol, nRow);
//STRIP001 
//STRIP001 		// es gibt nicht immer ein entspr. Objekt im Drawing-Layer
//STRIP001 		if (pObj)
//STRIP001 		{
//STRIP001 							// nicht mergen, nicht BuildChart() rufen
//STRIP001 			rDoc.ChangeDataPointAttr(*pNewAttr, *pObj, FALSE, FALSE);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			rDoc.PutDataPointAttr(nCol, nRow, *pNewAttr,FALSE);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	rDoc.BuildChart(FALSE);
//STRIP001 }

/*************************************************************************
|*
|* CanRepeat()
|*
\************************************************************************/

//STRIP001 BOOL SchUndoMultipleDataPoints::CanRepeat(SfxRepeatTarget& rView) const
//STRIP001 {
//STRIP001 	return FALSE;
//STRIP001 }



}
