/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: tabstpge.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 15:07:44 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SVX_TABSTPGE_HXX
#define _SVX_TABSTPGE_HXX

// include ---------------------------------------------------------------

#include <vcl/group.hxx>
#include <vcl/edit.hxx>
#include <vcl/field.hxx>
#include <vcl/fixed.hxx>
#include <bf_sfx2/tabdlg.hxx>

#include <bf_svx/tstpitem.hxx>
namespace binfilter {

// forward ---------------------------------------------------------------

//STRIP001 class TabWin_Impl;

// define ----------------------------------------------------------------

// Bitfelder f"ur DisableControls()
//STRIP001 #define TABTYPE_LEFT		0x0001
//STRIP001 #define TABTYPE_RIGHT		0x0002
//STRIP001 #define TABTYPE_CENTER		0x0004
//STRIP001 #define TABTYPE_DEZIMAL		0x0008
//STRIP001 #define TABTYPE_ALL			0x000F

//STRIP001 #define TABFILL_NONE		0x0010
//STRIP001 #define TABFILL_POINT		0x0020
//STRIP001 #define TABFILL_DASHLINE 	0x0040
//STRIP001 #define TABFILL_SOLIDLINE	0x0080
//STRIP001 #define TABFILL_SPECIAL		0x0100
//STRIP001 #define TABFILL_ALL			0x01F0

// class SvxTabulatorTabPage ---------------------------------------------
/*
	{k:\svx\prototyp\dialog\tabstop.bmp}

	[Beschreibung]
	In dieser TabPage werden Tabulatoren verwaltet.

	[Items]
	<SvxTabStopItem><SID_ATTR_TABSTOP>
	<SfxUInt16Item><SID_ATTR_TABSTOP_DEFAULTS>
	<SfxUInt16Item><SID_ATTR_TABSTOP_POS>
	<SfxInt32Item><SID_ATTR_TABSTOP_OFFSET>
*/

//STRIP001 class SvxTabulatorTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 	~SvxTabulatorTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage* 	Create( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	static USHORT*		GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual void 		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void				DisableControls( const USHORT nFlag );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 private:
//STRIP001 	SvxTabulatorTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	// Tabulatoren und Positionen
//STRIP001 	MetricBox		aTabBox;
//STRIP001     FixedLine       aTabLabel;
//STRIP001     FixedLine       aTabLabelVert;
//STRIP001 
//STRIP001 	// TabType
//STRIP001 	RadioButton		aLeftTab;
//STRIP001 	RadioButton		aRightTab;
//STRIP001 	RadioButton		aCenterTab;
//STRIP001 	RadioButton		aDezTab;
//STRIP001 
//STRIP001 	TabWin_Impl*	pLeftWin;
//STRIP001 	TabWin_Impl*	pRightWin;
//STRIP001 	TabWin_Impl*	pCenterWin;
//STRIP001 	TabWin_Impl*	pDezWin;
//STRIP001 
//STRIP001 	FixedText		aDezCharLabel;
//STRIP001 	Edit			aDezChar;
//STRIP001     FixedLine       aTabTypeLabel;
//STRIP001     FixedLine       aTabTypeLabelVert;
//STRIP001 
//STRIP001 	// Fuellzeichen
//STRIP001 	RadioButton		aNoFillChar;
//STRIP001 	RadioButton		aFillPoints;
//STRIP001 	RadioButton		aFillDashLine ;
//STRIP001 	RadioButton		aFillSolidLine;
//STRIP001 	RadioButton		aFillSpecial;
//STRIP001 	Edit			aFillChar;
//STRIP001     FixedLine       aFillLabel;
//STRIP001 
//STRIP001 	// Buttons
//STRIP001 	PushButton		aNewBtn;
//STRIP001 	PushButton		aDelAllBtn;
//STRIP001 	PushButton		aDelBtn;
//STRIP001 
//STRIP001 	// lokale Variablen, interne Funktionen
//STRIP001 	SvxTabStop     	aAktTab;
//STRIP001 	SvxTabStopItem	aNewTabs;
//STRIP001 	long			nDefDist;
//STRIP001 	FieldUnit		eDefUnit;
//STRIP001 	BOOL			bCheck;
//STRIP001 
//STRIP001 #ifdef _SVX_TABSTPGE_CXX
//STRIP001 	void 			InitTabPos_Impl( USHORT nPos = 0 );
//STRIP001 	void 			SetFillAndTabType_Impl();
//STRIP001 
//STRIP001 	// Handler
//STRIP001 	DECL_LINK( NewHdl_Impl, Button* );
//STRIP001 	DECL_LINK( DelHdl_Impl, Button* );
//STRIP001 	DECL_LINK( DelAllHdl_Impl, Button* );
//STRIP001 
//STRIP001 	DECL_LINK( FillTypeCheckHdl_Impl, RadioButton* );
//STRIP001 	DECL_LINK( TabTypeCheckHdl_Impl, RadioButton* );
//STRIP001 
//STRIP001 	DECL_LINK( SelectHdl_Impl, MetricBox* );
//STRIP001 	DECL_LINK( ModifyHdl_Impl, MetricBox* );
//STRIP001 	DECL_LINK( GetFillCharHdl_Impl, Edit* );
//STRIP001 	DECL_LINK( GetDezCharHdl_Impl, Edit* );
//STRIP001 #endif
//STRIP001 };

}//end of namespace binfilter
#endif // #ifndef _SVX_TABSTPGE_HXX

